package spoke.misc.learning;

import spoke.signal.kohonen.*;

public class Ligne extends SOM {
	protected int size;

	public Ligne(int dimension, int size) {
		super(dimension);
		this.size=size;
		node=new SOMNode[size];
		for(int i=0;i<node.length;i++) node[i]=node(i);
		r=size/2.;
		l=.2;
	}

	public SOMNode node(int n) {
		SOMNode node=new SOMNode(Node.randomize(dimension));
		int x=n;
		if(x==0 || x==size-1) {
			node.addElement(new Proximite(x==0?x+1:x-1));
		} else {
			node.addElement(new Proximite(x-1));
			node.addElement(new Proximite(x+1));
		}
//		node.addElement(new Proximite(x==0?size-1:x-1));
//		node.addElement(new Proximite(x==size-1?0:x+1));
		node.trimToSize();
		return node;
	}
}
