package spoke.misc.learning;

public class Timer implements Runnable {
	Timeable timeable;
	long interval;
	Thread thread;

	public Timer(Timeable timeable, long interval) {
		this.timeable=timeable;
		this.interval=interval;
		thread=new Thread(this);
	}

	public void run() {
		while(true) {
			Thread tick=new Thread() {
				public void run() {
					timeable.tick(Timer.this);
				}
			};
			tick.start();
			do {
				try {
					Thread.sleep(interval);
				} catch (InterruptedException ex) {}
			} while(tick.isAlive());
		}
	}

	public void cont() {
		if(thread.isAlive()) thread.resume();
		else thread.start();
	}

	public void stop() {
		thread.suspend();
	}
}
